[[FX]]

// Samplers
sampler2D albedoMap;
sampler2D normalMap = sampler_state
{
	Texture = "textures/common/defnorm.tga";
};

samplerCube ambientMap = sampler_state
{
	Address = Clamp;
	Filter = Bilinear;
	MaxAnisotropy = 1;
};

samplerCube envMap = sampler_state
{
	Address = Clamp;
	Filter = Bilinear;
	MaxAnisotropy = 1;
};

// Uniforms
float4 specParams <
	string desc_a = "a: specular mask";
	string desc_b = "b: specular exponent";
> = {0.1, 16.0, 0, 0};

context LIGHTING
{
	VertexShader = compile GLSL VS_GENERAL;
	PixelShader = compile GLSL FS_LIGHTING;
	
	ZWriteEnable = false;
	BlendMode = Add;
}

context AMBIENT
{
	VertexShader = compile GLSL VS_GENERAL;
	PixelShader = compile GLSL FS_AMBIENT;
}


[[VS_GENERAL]]
// =================================================================================================

uniform mat4 viewProjMat;
uniform mat4 worldMat;
attribute vec3 gl_Vertex = vertPos;
attribute vec2 gl_MultiTexcoord0 = texCoords0;
attribute vec3 gl_Normal = normal;

ProjectionMatrix = viewProjMat;
ModelViewMatrix = worldMat;

LightingEnabled = True;
LightModelAmbient = vec4(0,0,0,0);

LightEnabled[0] = True;
LightPosition[0] = vec4(0,1,0,0);
LightAmbient[0] = vec4(0.2,0.2,0.2,0);
LightDiffuse[0] = vec4(0.8,0.8,0.8,1);
LightEmission[0] = vec4(1,1,1,1);

RescaleNormalEnabled = True;

MaterialAmbient = vec4(1,1,1,1);
MaterialDiffuse = vec4(1,1,1,1);
MaterialEmission = vec4(0,0,0,1);

[[FS_LIGHTING]]
// =================================================================================================

Rgb[0] = Replace(Texture);
Alpha[0] = Replace(Texture);

[[FS_AMBIENT]]	
// =================================================================================================

uniform sampler2D albedoMap;

Rgb[0] = Modulate(Texture,PrimaryColor);
Alpha[0] = Replace(Texture);

